;;; 
;;; Startup file for Linux Zaurus SL-C series.
;;; for Emacs 22.0.50
;;;
;;; added by Hiroshi Maruyama <maru@focv.com>
;;;

;;;
;;; to suppress "listing directory failed" message on arm-sharp-linux-gnu.
;;;
(setq dired-use-ls-dired nil)
;;; 
;;; to suppress dizzy listing of `ls' command in M-x shell
;;;
(add-hook 'shell-mode-hook 'ansi-color-for-comint-mode-on)

;;;
;;; Special Thanks to Hideyuki Shirai
;;;
;;; to prevent from confusion with Emacs's DNS cache in mobile use.
;;;
(defun zaurus-host-to-ip (host)
  "Convert hostname to IP-Address for Zaurus network."
  (if (string-match "^[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+$" host)
      host
    (condition-case nil
	(with-temp-buffer
	  (call-process "nslookup" nil (current-buffer) nil host)
	  (goto-char (point-min))
	  (when (re-search-forward "^Name: +" nil t)
	    (forward-line 1)
	    (when (looking-at "^Address\\(es\\)?: +\\([0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+\\)")
	      (setq host (match-string 2))))
	  host)
      (error host))))
(defadvice open-network-stream (around get-ipaddr activate)
  "Convert host to IP-Address."
  (setq host (or (zaurus-host-to-ip host) host))
  ad-do-it)
